"use strict";
//@ts-nocheck
const JavaFile = Java.type("java.io.File");
const JavaClass = Java.type("java.lang.Class");
const Thread = Java.type("java.lang.Thread");
const URLClassLoader = Java.type("java.net.URLClassLoader");
const Files = Java.type("java.nio.file.Files");
const StandardOpenOption = Java.type("java.nio.file.StandardOpenOption");
const Base64 = Java.type("java.util.Base64");
const LiquidBounce = Java.type("net.ccbluex.liquidbounce.LiquidBounce");
const ScriptManager = Java.type("net.ccbluex.liquidbounce.script.ScriptManager");
const script = registerScript({
    name: "GCoreLoader",
    version: "0.1",
    authors: ["Godden"]
});
class GCoreLoader {
    static dir = new JavaFile(ScriptManager.INSTANCE.getScriptsRoot(), "GoddenScript\\lib");
    static jarFile = new JavaFile(this.dir, "GCore-0.1.jar");
    static classLoader;
    static INSTANCE;
    static {
        try {
            this.classLoader = new URLClassLoader([this.jarFile.toURL()], Thread.currentThread().getContextClassLoader());
        }
        catch (error) {
            LiquidBounce.INSTANCE.getLogger().error(`[${script.scriptName}] Exception!`, error);
        }
    }
    static load() {
        try {
            if (!this.dir.exists() || !this.dir.isDirectory()) {
                this.dir.mkdirs();
            }
            const clazz = this.classLoader.loadClass("dev.godden.core.GCore");
            this.INSTANCE = clazz.getField("INSTANCE").get(null);
            this.INSTANCE.onEnable();
        }
        catch (error) {
            LiquidBounce.INSTANCE.getLogger().error(`[${script.scriptName}] Exception!`, error);
        }
    }
    static unload() {
        this.INSTANCE.onDisable();
        this.classLoader.close();
    }
}
script.on("enable", () => {
    GCoreLoader.load();
});
script.on("disable", () => {
    GCoreLoader.unload();
});
